%define anolis_release 71

# define openjade version to format the sgml and xml files
%global openjade_version 1.3.2

# define the list of versions to build
# it has to be expanded in the spec file to maintain the order.
%global build_targets \\\
  3.0-sgml \\\
  3.1-sgml \\\
  4.0-sgml \\\
  4.1-sgml \\\
  4.2-sgml \\\
  4.3-sgml \\\
  4.4-sgml \\\
  4.5-sgml \\\
  4.1.2-xml \\\
  4.2-xml \\\
  4.3-xml \\\
  4.4-xml \\\
  4.5-xml \\\
  4.2-rng \\\
  4.3-rng \\\
  4.4-rng \\\
  4.5-rng \\\
  4.2-xsd \\\
  4.3-xsd \\\
  4.4-xsd \\\
  4.5-xsd

# defind the list of destination directories
# it has to be expanded in the spec file to maintain the order too.
%global dst_directories \\\
  3.0-sgml \\\
  3.1-sgml \\\
  4.0-sgml \\\
  4.1-sgml \\\
  4.2-sgml \\\
  4.3-sgml \\\
  4.4-sgml \\\
  4.5-sgml \\\
  4.1.2-xml \\\
  4.2-xml \\\
  4.3-xml \\\
  4.4-xml \\\
  4.5-xml

Summary: SGML and XML document type definitions for DocBook
Name: docbook-dtds
Version: 1.0
Release: %{anolis_release}%{?dist}
License: Copyright only
URL: http://www.oasis-open.org/docbook/
BuildArch: noarch

# sources for the SGML DTDs
Source0: %{url}/sgml/3.0/docbk30.zip
Source1: %{url}/sgml/3.1/docbk31.zip
Source2: %{url}/sgml/4.0/docbk40.zip
Source3: %{url}/sgml/4.1/docbk41.zip
Source4: %{url}/sgml/4.2/docbook-4.2.zip
Source5: %{url}/sgml/4.3/docbook-4.3.zip
Source6: %{url}/sgml/4.4/docbook-4.4.zip
Source7: %{url}/sgml/4.5/docbook-4.5.zip

# sources for the XML DTDs and schemas
Source8: %{url}/xml/4.1.2/docbkx412.zip
Source9: %{url}/xml/4.2/docbook-xml-4.2.zip
Source10: %{url}/xml/4.3/docbook-xml-4.3.zip
Source11: %{url}/xml/4.4/docbook-xml-4.4.zip
Source12: %{url}/xml/4.5/docbook-xml-4.5.zip

# sources for the RELAX NG Grammars
Source13: %{url}/rng/4.2/docbook-rng-4.2.zip
Source14: %{url}/rng/4.3/docbook-rng-4.3.zip
Source15: %{url}/rng/4.4/docbook-rng-4.4.zip
# upstream url is not containing the zip file for docbook-rng-4.5.zip
Source16: docbook-rng-4.5.zip

# sources for the W3C XML Schema Grammars
Source17: %{url}/xsd/4.2/docbook-xsd-4.2.zip
Source18: %{url}/xsd/4.3/docbook-xsd-4.3.zip
Source19: %{url}/xsd/4.4/docbook-xsd-4.4.zip
# upstream url is not containing the zip file for docbook-xsd-4.5.zip
Source20: docbook-xsd-4.5.zip

#fix old catalog files
Patch0: docbook-dtd30-sgml-1.0.catalog.patch
Patch1: docbook-dtd31-sgml-1.0.catalog.patch
Patch2: docbook-dtd40-sgml-1.0.catalog.patch
Patch3: docbook-dtd41-sgml-1.0.catalog.patch
Patch4: docbook-dtd42-sgml-1.0.catalog.patch
#fix euro sign in 4.2 dtds
Patch5: docbook-4.2-euro.patch
#Fix ISO entities in 4.3/4.4/4.5 SGML
Patch6: docbook-dtds-ents.patch
#Use system rewrite for web URL's in sgml catalogs to prevent reading from the network(#478680)
Patch7: docbook-sgml-systemrewrite.patch
#use XML at the end of public identificators of XML 4.1.2 ISO entities
Patch8: docbook-dtd412-entities.patch

Obsoletes: docbook-dtd30-sgml < %{version}-%{release}
Obsoletes: docbook-dtd31-sgml < %{version}-%{release}
Obsoletes: docbook-dtd40-sgml < %{version}-%{release}
Obsoletes: docbook-dtd41-sgml < %{version}-%{release}
Obsoletes: docbook-dtd412-xml < %{version}-%{release}

# provide versions of sgml dtds
Provides: docbook-dtd-sgml   = %{version}-%{release}
Provides: docbook-dtd30-sgml = %{version}-%{release}
Provides: docbook-dtd31-sgml = %{version}-%{release}
Provides: docbook-dtd40-sgml = %{version}-%{release}
Provides: docbook-dtd41-sgml = %{version}-%{release}
Provides: docbook-dtd42-sgml = %{version}-%{release}
Provides: docbook-dtd43-sgml = %{version}-%{release}
Provides: docbook-dtd44-sgml = %{version}-%{release}
Provides: docbook-dtd45-sgml = %{version}-%{release}

# provide versions of xml dtds
Provides: docbook-dtd-xml    = %{version}-%{release}
Provides: docbook-dtd412-xml = %{version}-%{release}
Provides: docbook-dtd42-xml  = %{version}-%{release}
Provides: docbook-dtd43-xml  = %{version}-%{release}
Provides: docbook-dtd44-xml  = %{version}-%{release}
Provides: docbook-dtd45-xml  = %{version}-%{release}

Requires: sgml-common xml-common
Requires(post): /usr/bin/xmlcatalog
Requires(postun): /usr/bin/xmlcatalog
Requires(post): sed
Requires(postun): sed

%description
DocBook DTDs (Document Type Definitions) are a set of markup rules
that define the structure and content of technical documentation.
They provide a standardized way of creating and formatting documents
for different output formats like HTML, PDF, or print. DocBook
DTDs are XML-based and define elements like chapters, sections,
lists, tables, and other common document components. They also provide
guidelines for metadata, linking, and document organization. DocBook
DTDs are widely used in technical writing and publishing industries,
providing a reliable and flexible way of creating and managing documentation.

This package contains SGML and XML versions of the DocBook document type definitions.

%package doc
Summary: Doc files for %{name}
BuildArch: noarch
Requires: %{name} = %{version}-%{release}

%description doc
This package contains documentation files for %{name}.

%prep
# Unpack the sources by standard rpm macros setup and patch to avoid including
# extra redundant build requinrements for unzip and patch.
# Set up the SGML DTDs
%setup -c -a0 -D -T -n 3.0-sgml
# Still in 3.0-sgml directory after setup, so just patch with -p0.
# It is also same for 3.1-sgml, 4.0-sgml, 4.1-sgml, 4.2-sgml
%patch0 -p0 -b docbook.cat

%setup -c -a1 -D -T -n 3.1-sgml
%patch1 -p0 -b docbook.cat

%setup -c -a2 -D -T -n 4.0-sgml
%patch2 -p0 -b docbook.cat

%setup -c -a3 -D -T -n 4.1-sgml
%patch3 -p0 -b docbook.cat

%setup -c -a4 -D -T -n 4.2-sgml
%patch4 -p0 -b docbook.cat

%setup -c -a5 -D -T -n 4.3-sgml
%setup -c -a6 -D -T -n 4.4-sgml
%setup -c -a7 -D -T -n 4.5-sgml

# Set up the XML DTDs and schemas
%setup -c -a8 -D -T -n 4.1.2-xml
%setup -c -a9 -D -T -n 4.2-xml
%setup -c -a10 -D -T -n 4.3-xml
%setup -c -a11 -D -T -n 4.4-xml
%setup -c -a12 -D -T -n 4.5-xml

# Set up for RELAX NG Grammars
%setup -c -a13 -D -T -n 4.2-rng
%setup -c -a14 -D -T -n 4.3-rng
%setup -c -a15 -D -T -n 4.4-rng
%setup -c -a16 -D -T -n 4.5-rng

# Set up the W3C XML Schema Grammars
%setup -c -a17 -D -T -n 4.2-xsd
%setup -c -a18 -D -T -n 4.3-xsd
%setup -c -a19 -D -T -n 4.4-xsd
%setup -c -a20 -D -T -n 4.5-xsd

# Move all files to the root of the build directory.
# This is needed for the %%install section to work.
%setup -c -T
for target in %{build_targets}; do
  mv %{_builddir}/$target $target
done
# Patch the rest of the patches.
# The patches are numbered 5-8, the first 5 are already applied.
%autopatch -p1 -m 5 -M 8

# Increase NAMELEN (bug #36058, bug #159382).
sed -e 's,\(NAMELEN\s\+\)44\(\s\*\)\?,\1256,' -i.namelen */docbook.dcl

# remove DOS line endings
sed -i 's/\r//' */*.txt

%build
# Don't need to build anything. Just unpack the files.

%install
# Make symlinks for docbook.cat
mkdir -p $RPM_BUILD_ROOT/etc/sgml
ln -s sgml-docbook-4.5.cat $RPM_BUILD_ROOT/etc/sgml/sgml-docbook.cat
ln -s xml-docbook-4.5.cat $RPM_BUILD_ROOT/etc/sgml/xml-docbook.cat

for target in %{build_targets}; do
  cd $target
  fmt=${target#*-}
  ver=${target%%-*}
  case $fmt in
    sgml)   DESTDIR=$RPM_BUILD_ROOT/usr/share/sgml/docbook/$fmt-dtd-$ver 
            mkdir -p $DESTDIR
            install -m 0644 -p *.dcl $DESTDIR
            install -m 0644 -p *.dtd *.mod $DESTDIR
            install -m 0644 -p docbook.cat $DESTDIR/catalog ;;
    xml)    DESTDIR=$RPM_BUILD_ROOT/usr/share/sgml/docbook/$fmt-dtd-$ver
            mkdir -p $DESTDIR/ent
            install -m 0644 -p ent/* $DESTDIR/ent
            install -m 0644 -p *.dtd *.mod $DESTDIR
            install -m 0644 -p docbook.cat $DESTDIR/catalog ;;
    rng)    DESTDIR=$RPM_BUILD_ROOT/usr/share/sgml/docbook/$fmt-$ver 
            mkdir -p $DESTDIR
            install -m 0644 -p *.r* $DESTDIR ;;
    xsd)    DESTDIR=$RPM_BUILD_ROOT/usr/share/sgml/docbook/$fmt-$ver 
            mkdir -p $DESTDIR
            install -m 0644 -p *.xsd $DESTDIR ;;
  esac
  cd ..
  case $fmt in
    sgml|xml)
            # File for %%ghost
            touch $RPM_BUILD_ROOT/etc/sgml/$fmt-docbook-$ver.cat;;
  esac 
done

mkdir -p $RPM_BUILD_ROOT%{_pkgdocdir}
for i in */*.txt */ChangeLog */README; do
  install -m 0644 -p $i $RPM_BUILD_ROOT%{_pkgdocdir}
done

%post
catcmd='/usr/bin/xmlcatalog --noout'
xmlcatalog=/usr/share/sgml/docbook/xmlcatalog

## Clean up pre-docbook-dtds mess caused by broken trigger.
for v in 3.0 3.1 4.0 4.1 4.2; do
  if [ -f /etc/sgml/sgml-docbook-$v.cat ]; then
    $catcmd --sgml --del /etc/sgml/sgml-docbook-$v.cat \
      /usr/share/sgml/openjade-%{openjade_version}/catalog 2>/dev/null
  fi
done

# The STYLESHEETS/catalog command is for the case in which the style sheets
# were installed after another DTD but before this DTD
for STYLESHEETS in /usr/share/sgml/docbook/dsssl-stylesheets-*; do : ; done
case $STYLESHEETS in
  *-"*") STYLESHEETS= ;;
esac

for dir in %{dst_directories}; do
  fmt=${dir#*-}
  ver=${dir%%-*}
  sgmldir=/usr/share/sgml/docbook/$fmt-dtd-$ver
  ## Update SGML catalog
  for cat_dir in /usr/share/sgml/sgml-iso-entities-8879.1986 $sgmldir $STYLESHEETS; do
    $catcmd --sgml --add /etc/sgml/$fmt-docbook-$ver.cat $cat_dir/catalog
  done
  ## Update XML catalog
  if [ $fmt = xml -a -w $xmlcatalog ]; then
    while read f desc; do
      case $ver in 
        4.[45]) f=${f/-/} ;; 
      esac
      $catcmd --add public "$desc" $sgmldir/$f $xmlcatalog
    done << ENDENT
      ent/iso-pub.ent	ISO 8879:1986//ENTITIES Publishing//EN
      ent/iso-grk1.ent	ISO 8879:1986//ENTITIES Greek Letters//EN
      dbpoolx.mod	-//OASIS//ELEMENTS DocBook XML Information Pool V$ver//EN
      ent/iso-box.ent	ISO 8879:1986//ENTITIES Box and Line Drawing//EN
      docbookx.dtd	-//OASIS//DTD DocBook XML V$ver//EN
      ent/iso-grk3.ent	ISO 8879:1986//ENTITIES Greek Symbols//EN
      ent/iso-amsn.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Negated Relations//EN
      ent/iso-num.ent	ISO 8879:1986//ENTITIES Numeric and Special Graphic//EN
      dbcentx.mod	-//OASIS//ENTITIES DocBook XML Character Entities V$ver//EN
      ent/iso-grk4.ent	ISO 8879:1986//ENTITIES Alternative Greek Symbols//EN
      dbnotnx.mod	-//OASIS//ENTITIES DocBook XML Notations V$ver//EN
      ent/iso-dia.ent	ISO 8879:1986//ENTITIES Diacritical Marks//EN
      ent/iso-grk2.ent	ISO 8879:1986//ENTITIES Monotoniko Greek//EN
      dbgenent.mod	-//OASIS//ENTITIES DocBook XML Additional General Entities V$ver//EN
      dbhierx.mod	-//OASIS//ELEMENTS DocBook XML Document Hierarchy V$ver//EN
      ent/iso-amsa.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Arrow Relations//EN
      ent/iso-amso.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Ordinary//EN
      ent/iso-cyr1.ent	ISO 8879:1986//ENTITIES Russian Cyrillic//EN
      ent/iso-tech.ent	ISO 8879:1986//ENTITIES General Technical//EN
      ent/iso-amsc.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Delimiters//EN
      soextblx.dtd	-//OASIS//DTD XML Exchange Table Model 19990315//EN
      calstblx.dtd	-//OASIS//DTD DocBook XML CALS Table Model V$ver//EN
      ent/iso-lat1.ent	ISO 8879:1986//ENTITIES Added Latin 1//EN
      ent/iso-amsb.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Binary Operators//EN
      ent/iso-lat2.ent	ISO 8879:1986//ENTITIES Added Latin 2//EN
      ent/iso-amsr.ent	ISO 8879:1986//ENTITIES Added Math Symbols: Relations//EN
      ent/iso-cyr2.ent	ISO 8879:1986//ENTITIES Non-Russian Cyrillic//EN
ENDENT
    $catcmd --add rewriteSystem "http://www.oasis-open.org/docbook/xml/$ver" \
      $sgmldir $xmlcatalog
    $catcmd --add rewriteURI "http://www.oasis-open.org/docbook/xml/$ver" \
      $sgmldir $xmlcatalog
  fi
done

# Make sure the catalog is sorted by the order in which SGML before XML.
# SGML tools may not work if the XML entries are before the SGML entries.
# This is important because xmlcatalog may reorder the line.
sed -ni '
  /xml-docbook/ H
  /xml-docbook/ !p
  $ {
          g
          s/^\n//p
  }
  ' /etc/sgml/catalog

%postun
if [ "$1" = 0 ]; then
  catcmd='/usr/bin/xmlcatalog --noout'
  xmlcatalog=/usr/share/sgml/docbook/xmlcatalog
  entities="
ent/iso-pub.ent
ent/iso-grk1.ent
dbpoolx.mod
ent/iso-box.ent
docbookx.dtd
ent/iso-grk3.ent
ent/iso-amsn.ent
ent/iso-num.ent
dbcentx.mod
ent/iso-grk4.ent
dbnotnx.mod
ent/iso-dia.ent
ent/iso-grk2.ent
dbgenent.mod
dbhierx.mod
ent/iso-amsa.ent
ent/iso-amso.ent
ent/iso-cyr1.ent
ent/iso-tech.ent
ent/iso-amsc.ent
soextblx.dtd
calstblx.dtd
ent/iso-lat1.ent
ent/iso-amsb.ent
ent/iso-lat2.ent
ent/iso-amsr.ent
ent/iso-cyr2.ent
  "

  for dir in %{dst_directories}; do
    fmt=${dir#*-}
    ver=${dir%%-*}
    sgmldir=/usr/share/sgml/docbook/$fmt-dtd-$ver
    ## SGML catalog
    $catcmd --sgml --del /etc/sgml/catalog /etc/sgml/$fmt-docbook-$ver.cat >/dev/null
    rm -f /etc/sgml/$fmt-docbook-$ver.cat
    ## XML catalog
    if [ $fmt = xml -a -w $xmlcatalog ]; then
      for f in $entities; do
        case $ver in 
          4.[45]) f=${f/-/} ;; 
        esac
        $catcmd --del $sgmldir/$f $xmlcatalog >/dev/null
      done
      $catcmd --del $sgmldir $xmlcatalog >/dev/null
    fi
  done

  # Same reason as above in %%post
  sed -ni '
  /xml-docbook/ H
  /xml-docbook/ !p
  $ {
          g
          s/^\n//p
  }
    ' /etc/sgml/catalog
fi

%triggerin -- openjade >= %{openjade_version}
for dir in %{dst_directories}; do
  fmt=${dir#*-}
  ver=${dir%%-*}
  /usr/bin/xmlcatalog --sgml --noout --add /etc/sgml/$fmt-docbook-$ver.cat \
    /usr/share/sgml/openjade-%{openjade_version}/catalog
done

%triggerun -- openjade >= %{openjade_version}
[ $2 = 0 ] || exit 0
for dir in %{dst_directories}; do
  fmt=${dir#*-}
  ver=${dir%%-*}
  /usr/bin/xmlcatalog --sgml --noout --del /etc/sgml/$fmt-docbook-$ver.cat \
    /usr/share/sgml/openjade-%{openjade_version}/catalog
done

%files
/usr/share/sgml/docbook/*ml-dtd-*
/usr/share/sgml/docbook/rng-*
/usr/share/sgml/docbook/xsd-*
%config(noreplace) /etc/sgml/*ml-docbook.cat
%ghost %config(noreplace) /etc/sgml/*ml-docbook-*.cat

%files doc
%doc %{_pkgdocdir}

%changelog
* Mon Apr 10 2023 Kun(llfl) <llfl@linux.alibaba.com> - 1.0-71
- optimize spec file
- change the prep stage to a standard macro approach
- add a new macro to define the destination catalog

* Sat Dec 10 2022 Funda Wang <fundawang@yeah.net> - 1.0-70
- Import 1.0
